Code

tests: unset COLUMNS inherited from environment
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 # A call to "unset" with no arguments causes at least Solaris 10
46 # /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
47 # deriving from the command substitution clustered with the other
48 # ones.
49 unset VISUAL EMAIL LANGUAGE COLUMNS $(perl -e '
50         my @env = keys %ENV;
51         my $ok = join("|", qw(
52                 TRACE
53                 DEBUG
54                 USE_LOOKUP
55                 TEST
56                 .*_TEST
57                 PROVE
58                 VALGRIND
59                 PERF_AGGREGATING_LATER
60         ));
61         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
62         print join("\n", @vars);
63 ')
64 GIT_AUTHOR_EMAIL=author@example.com
65 GIT_AUTHOR_NAME='A U Thor'
66 GIT_COMMITTER_EMAIL=committer@example.com
67 GIT_COMMITTER_NAME='C O Mitter'
68 GIT_MERGE_VERBOSITY=5
69 GIT_MERGE_AUTOEDIT=no
70 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
71 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
72 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
73 export EDITOR
75 # Protect ourselves from common misconfiguration to export
76 # CDPATH into the environment
77 unset CDPATH
79 unset GREP_OPTIONS
81 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
82         1|2|true)
83                 echo "* warning: Some tests will not work if GIT_TRACE" \
84                         "is set as to trace on STDERR ! *"
85                 echo "* warning: Please set GIT_TRACE to something" \
86                         "other than 1, 2 or true ! *"
87                 ;;
88 esac
90 # Convenience
91 #
92 # A regexp to match 5 and 40 hexdigits
93 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
94 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
96 # Zero SHA-1
97 _z40=0000000000000000000000000000000000000000
99 # Line feed
100 LF='
103 export _x05 _x40 _z40 LF
105 # Each test should start with something like this, after copyright notices:
107 # test_description='Description of this test...
108 # This test checks if command xyzzy does the right thing...
109 # '
110 # . ./test-lib.sh
111 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
112                 TERM=$ORIGINAL_TERM &&
113                 export TERM &&
114                 [ -t 1 ] &&
115                 tput bold >/dev/null 2>&1 &&
116                 tput setaf 1 >/dev/null 2>&1 &&
117                 tput sgr0 >/dev/null 2>&1
118         ) &&
119         color=t
121 while test "$#" -ne 0
122 do
123         case "$1" in
124         -d|--d|--de|--deb|--debu|--debug)
125                 debug=t; shift ;;
126         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
127                 immediate=t; shift ;;
128         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
129                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
130         -h|--h|--he|--hel|--help)
131                 help=t; shift ;;
132         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
133                 verbose=t; shift ;;
134         -q|--q|--qu|--qui|--quie|--quiet)
135                 # Ignore --quiet under a TAP::Harness. Saying how many tests
136                 # passed without the ok/not ok details is always an error.
137                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
138         --with-dashes)
139                 with_dashes=t; shift ;;
140         --no-color)
141                 color=; shift ;;
142         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
143                 valgrind=t; verbose=t; shift ;;
144         --tee)
145                 shift ;; # was handled already
146         --root=*)
147                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
148                 shift ;;
149         *)
150                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
151         esac
152 done
154 if test -n "$color"; then
155         say_color () {
156                 (
157                 TERM=$ORIGINAL_TERM
158                 export TERM
159                 case "$1" in
160                         error) tput bold; tput setaf 1;; # bold red
161                         skip)  tput bold; tput setaf 2;; # bold green
162                         pass)  tput setaf 2;;            # green
163                         info)  tput setaf 3;;            # brown
164                         *) test -n "$quiet" && return;;
165                 esac
166                 shift
167                 printf "%s" "$*"
168                 tput sgr0
169                 echo
170                 )
171         }
172 else
173         say_color() {
174                 test -z "$1" && test -n "$quiet" && return
175                 shift
176                 echo "$*"
177         }
178 fi
180 error () {
181         say_color error "error: $*"
182         GIT_EXIT_OK=t
183         exit 1
186 say () {
187         say_color info "$*"
190 test "${test_description}" != "" ||
191 error "Test script did not set test_description."
193 if test "$help" = "t"
194 then
195         echo "$test_description"
196         exit 0
197 fi
199 exec 5>&1
200 exec 6<&0
201 if test "$verbose" = "t"
202 then
203         exec 4>&2 3>&1
204 else
205         exec 4>/dev/null 3>/dev/null
206 fi
208 test_failure=0
209 test_count=0
210 test_fixed=0
211 test_broken=0
212 test_success=0
214 test_external_has_tap=0
216 die () {
217         code=$?
218         if test -n "$GIT_EXIT_OK"
219         then
220                 exit $code
221         else
222                 echo >&5 "FATAL: Unexpected exit with code $code"
223                 exit 1
224         fi
227 GIT_EXIT_OK=
228 trap 'die' EXIT
230 # The user-facing functions are loaded from a separate file so that
231 # test_perf subshells can have them too
232 . "${TEST_DIRECTORY:-.}"/test-lib-functions.sh
234 # You are not expected to call test_ok_ and test_failure_ directly, use
235 # the text_expect_* functions instead.
237 test_ok_ () {
238         test_success=$(($test_success + 1))
239         say_color "" "ok $test_count - $@"
242 test_failure_ () {
243         test_failure=$(($test_failure + 1))
244         say_color error "not ok - $test_count $1"
245         shift
246         echo "$@" | sed -e 's/^/#       /'
247         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
250 test_known_broken_ok_ () {
251         test_fixed=$(($test_fixed+1))
252         say_color "" "ok $test_count - $@ # TODO known breakage"
255 test_known_broken_failure_ () {
256         test_broken=$(($test_broken+1))
257         say_color skip "not ok $test_count - $@ # TODO known breakage"
260 test_debug () {
261         test "$debug" = "" || eval "$1"
264 test_eval_ () {
265         # This is a separate function because some tests use
266         # "return" to end a test_expect_success block early.
267         eval </dev/null >&3 2>&4 "$*"
270 test_run_ () {
271         test_cleanup=:
272         expecting_failure=$2
273         test_eval_ "$1"
274         eval_ret=$?
276         if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
277         then
278                 test_eval_ "$test_cleanup"
279         fi
280         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
281                 echo ""
282         fi
283         return "$eval_ret"
286 test_skip () {
287         test_count=$(($test_count+1))
288         to_skip=
289         for skp in $GIT_SKIP_TESTS
290         do
291                 case $this_test.$test_count in
292                 $skp)
293                         to_skip=t
294                         break
295                 esac
296         done
297         if test -z "$to_skip" && test -n "$test_prereq" &&
298            ! test_have_prereq "$test_prereq"
299         then
300                 to_skip=t
301         fi
302         case "$to_skip" in
303         t)
304                 of_prereq=
305                 if test "$missing_prereq" != "$test_prereq"
306                 then
307                         of_prereq=" of $test_prereq"
308                 fi
310                 say_color skip >&3 "skipping test: $@"
311                 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
312                 : true
313                 ;;
314         *)
315                 false
316                 ;;
317         esac
320 # stub; perf-lib overrides it
321 test_at_end_hook_ () {
322         :
325 test_done () {
326         GIT_EXIT_OK=t
328         if test -z "$HARNESS_ACTIVE"; then
329                 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
330                 mkdir -p "$test_results_dir"
331                 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
333                 cat >>"$test_results_path" <<-EOF
334                 total $test_count
335                 success $test_success
336                 fixed $test_fixed
337                 broken $test_broken
338                 failed $test_failure
340                 EOF
341         fi
343         if test "$test_fixed" != 0
344         then
345                 say_color pass "# fixed $test_fixed known breakage(s)"
346         fi
347         if test "$test_broken" != 0
348         then
349                 say_color error "# still have $test_broken known breakage(s)"
350                 msg="remaining $(($test_count-$test_broken)) test(s)"
351         else
352                 msg="$test_count test(s)"
353         fi
354         case "$test_failure" in
355         0)
356                 # Maybe print SKIP message
357                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
359                 if test $test_external_has_tap -eq 0; then
360                         say_color pass "# passed all $msg"
361                         say "1..$test_count$skip_all"
362                 fi
364                 test -d "$remove_trash" &&
365                 cd "$(dirname "$remove_trash")" &&
366                 rm -rf "$(basename "$remove_trash")"
368                 test_at_end_hook_
370                 exit 0 ;;
372         *)
373                 if test $test_external_has_tap -eq 0; then
374                         say_color error "# failed $test_failure among $msg"
375                         say "1..$test_count"
376                 fi
378                 exit 1 ;;
380         esac
383 # Test the binaries we have just built.  The tests are kept in
384 # t/ subdirectory and are run in 'trash directory' subdirectory.
385 if test -z "$TEST_DIRECTORY"
386 then
387         # We allow tests to override this, in case they want to run tests
388         # outside of t/, e.g. for running tests on the test library
389         # itself.
390         TEST_DIRECTORY=$(pwd)
391 fi
392 if test -z "$TEST_OUTPUT_DIRECTORY"
393 then
394         # Similarly, override this to store the test-results subdir
395         # elsewhere
396         TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
397 fi
398 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
400 if test -n "$valgrind"
401 then
402         make_symlink () {
403                 test -h "$2" &&
404                 test "$1" = "$(readlink "$2")" || {
405                         # be super paranoid
406                         if mkdir "$2".lock
407                         then
408                                 rm -f "$2" &&
409                                 ln -s "$1" "$2" &&
410                                 rm -r "$2".lock
411                         else
412                                 while test -d "$2".lock
413                                 do
414                                         say "Waiting for lock on $2."
415                                         sleep 1
416                                 done
417                         fi
418                 }
419         }
421         make_valgrind_symlink () {
422                 # handle only executables, unless they are shell libraries that
423                 # need to be in the exec-path.  We will just use "#!" as a
424                 # guess for a shell-script, since we have no idea what the user
425                 # may have configured as the shell path.
426                 test -x "$1" ||
427                 test "#!" = "$(head -c 2 <"$1")" ||
428                 return;
430                 base=$(basename "$1")
431                 symlink_target=$GIT_BUILD_DIR/$base
432                 # do not override scripts
433                 if test -x "$symlink_target" &&
434                     test ! -d "$symlink_target" &&
435                     test "#!" != "$(head -c 2 < "$symlink_target")"
436                 then
437                         symlink_target=../valgrind.sh
438                 fi
439                 case "$base" in
440                 *.sh|*.perl)
441                         symlink_target=../unprocessed-script
442                 esac
443                 # create the link, or replace it if it is out of date
444                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
445         }
447         # override all git executables in TEST_DIRECTORY/..
448         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
449         mkdir -p "$GIT_VALGRIND"/bin
450         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
451         do
452                 make_valgrind_symlink $file
453         done
454         # special-case the mergetools loadables
455         make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
456         OLDIFS=$IFS
457         IFS=:
458         for path in $PATH
459         do
460                 ls "$path"/git-* 2> /dev/null |
461                 while read file
462                 do
463                         make_valgrind_symlink "$file"
464                 done
465         done
466         IFS=$OLDIFS
467         PATH=$GIT_VALGRIND/bin:$PATH
468         GIT_EXEC_PATH=$GIT_VALGRIND/bin
469         export GIT_VALGRIND
470 elif test -n "$GIT_TEST_INSTALLED" ; then
471         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
472         error "Cannot run git from $GIT_TEST_INSTALLED."
473         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
474         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
475 else # normal case, use ../bin-wrappers only unless $with_dashes:
476         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
477         if ! test -x "$git_bin_dir/git" ; then
478                 if test -z "$with_dashes" ; then
479                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
480                 fi
481                 with_dashes=t
482         fi
483         PATH="$git_bin_dir:$PATH"
484         GIT_EXEC_PATH=$GIT_BUILD_DIR
485         if test -n "$with_dashes" ; then
486                 PATH="$GIT_BUILD_DIR:$PATH"
487         fi
488 fi
489 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
490 unset GIT_CONFIG
491 GIT_CONFIG_NOSYSTEM=1
492 GIT_ATTR_NOSYSTEM=1
493 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
495 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
497 if test -z "$GIT_TEST_CMP"
498 then
499         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
500         then
501                 GIT_TEST_CMP="$DIFF -c"
502         else
503                 GIT_TEST_CMP="$DIFF -u"
504         fi
505 fi
507 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
508 export GITPERLLIB
509 test -d "$GIT_BUILD_DIR"/templates/blt || {
510         error "You haven't built things yet, have you?"
513 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
514 then
515         GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
516         export GITPYTHONLIB
517         test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
518                 error "You haven't built git_remote_helpers yet, have you?"
519         }
520 fi
522 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
523         echo >&2 'You need to build test-chmtime:'
524         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
525         exit 1
526 fi
528 # Test repository
529 test="trash directory.$(basename "$0" .sh)"
530 test -n "$root" && test="$root/$test"
531 case "$test" in
532 /*) TRASH_DIRECTORY="$test" ;;
533  *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$test" ;;
534 esac
535 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
536 rm -fr "$test" || {
537         GIT_EXIT_OK=t
538         echo >&5 "FATAL: Cannot prepare test area"
539         exit 1
542 HOME="$TRASH_DIRECTORY"
543 export HOME
545 if test -z "$TEST_NO_CREATE_REPO"; then
546         test_create_repo "$test"
547 else
548         mkdir -p "$test"
549 fi
550 # Use -P to resolve symlinks in our working directory so that the cwd
551 # in subprocesses like git equals our $PWD (for pathname comparisons).
552 cd -P "$test" || exit 1
554 this_test=${0##*/}
555 this_test=${this_test%%-*}
556 for skp in $GIT_SKIP_TESTS
557 do
558         case "$this_test" in
559         $skp)
560                 say_color skip >&3 "skipping test $this_test altogether"
561                 skip_all="skip all tests in $this_test"
562                 test_done
563         esac
564 done
566 # Provide an implementation of the 'yes' utility
567 yes () {
568         if test $# = 0
569         then
570                 y=y
571         else
572                 y="$*"
573         fi
575         while echo "$y"
576         do
577                 :
578         done
581 # Fix some commands on Windows
582 case $(uname -s) in
583 *MINGW*)
584         # Windows has its own (incompatible) sort and find
585         sort () {
586                 /usr/bin/sort "$@"
587         }
588         find () {
589                 /usr/bin/find "$@"
590         }
591         sum () {
592                 md5sum "$@"
593         }
594         # git sees Windows-style pwd
595         pwd () {
596                 builtin pwd -W
597         }
598         # no POSIX permissions
599         # backslashes in pathspec are converted to '/'
600         # exec does not inherit the PID
601         test_set_prereq MINGW
602         test_set_prereq SED_STRIPS_CR
603         ;;
604 *CYGWIN*)
605         test_set_prereq POSIXPERM
606         test_set_prereq EXECKEEPSPID
607         test_set_prereq NOT_MINGW
608         test_set_prereq SED_STRIPS_CR
609         ;;
610 *)
611         test_set_prereq POSIXPERM
612         test_set_prereq BSLASHPSPEC
613         test_set_prereq EXECKEEPSPID
614         test_set_prereq NOT_MINGW
615         ;;
616 esac
618 test -z "$NO_PERL" && test_set_prereq PERL
619 test -z "$NO_PYTHON" && test_set_prereq PYTHON
620 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
621 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
623 # Can we rely on git's output in the C locale?
624 if test -n "$GETTEXT_POISON"
625 then
626         GIT_GETTEXT_POISON=YesPlease
627         export GIT_GETTEXT_POISON
628         test_set_prereq GETTEXT_POISON
629 else
630         test_set_prereq C_LOCALE_OUTPUT
631 fi
633 # Use this instead of test_cmp to compare files that contain expected and
634 # actual output from git commands that can be translated.  When running
635 # under GETTEXT_POISON this pretends that the command produced expected
636 # results.
637 test_i18ncmp () {
638         test -n "$GETTEXT_POISON" || test_cmp "$@"
641 # Use this instead of "grep expected-string actual" to see if the
642 # output from a git command that can be translated either contains an
643 # expected string, or does not contain an unwanted one.  When running
644 # under GETTEXT_POISON this pretends that the command produced expected
645 # results.
646 test_i18ngrep () {
647         if test -n "$GETTEXT_POISON"
648         then
649             : # pretend success
650         elif test "x!" = "x$1"
651         then
652                 shift
653                 ! grep "$@"
654         else
655                 grep "$@"
656         fi
659 # test whether the filesystem supports symbolic links
660 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
661 rm -f y
663 # When the tests are run as root, permission tests will report that
664 # things are writable when they shouldn't be.
665 test -w / || test_set_prereq SANITY